#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include <string.h>
#include <time.h>

void random_sleep();
void* do_thread( void*);

// constants and global variables
#define ARR_SIZE 1000 * 10
#define NUM_THREADS 3

//------------------------------------------------
int main()
{
  pthread_t threads[NUM_THREADS];
  size_t stacksize;

  pthread_attr_t attr;
  printf("MAIN Thread starting...\n");

  pthread_attr_init(&attr);
  pthread_attr_getstacksize (&attr, &stacksize);
  printf("Thread DEFAULT stack size = %ld bytes\n",stacksize);
  
  // set the stack size by calling setstacksize;
  // // get the updated stack size
  // pthread_attr_getstacksize (&attr, &stacksize);
  // printf("After Seting... NOW stack size = %d bytes\n",stacksize);
  int* ptr;
  for (long int j=0; j < NUM_THREADS; j++)
  {
    ptr = malloc(sizeof(int));
    *ptr = j+1;
    pthread_create(&threads[j], &attr, do_thread, (void*) ptr);
  }


  // wait for threads to complete - complete this code
  for (int j=0; j < NUM_THREADS; j++)
  {
    pthread_join(threads[j], NULL);
  }

  

  printf("MAIN Thread: ALL Threads terminated! Going to exit.\n");
  pthread_exit(NULL);
  // exit(0);
}

//------------------------------------------------
void* do_thread( void *ptr )
{
  int big_arr[ARR_SIZE];
  int num = *((int*) ptr);
  int j;
  printf("Thread #%d starting...\n", num);
  random_sleep();
  for (j=0; j < ARR_SIZE; j++)
    big_arr[j] = num;
  
  big_arr[0] = big_arr[1];  // does nothing. Just to prevent gcc Warning  
  printf("Thread #%d ending...\n", num);
  
  pthread_exit(NULL);  
}

//-------------------------------------------------
void random_sleep()
{
  int d = (rand() ^ pthread_self() ^ getpid()) % 40 + 40;
  const struct timespec ts = {0, d * 1000 * 1000 * 10};
  nanosleep(&ts, NULL);
}
