#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include <time.h>

/*
This program demonstrates returning of value from thread 
and getting it using pthread_join(...).

the program might crash or work incorrectly.  
Figure out the cause and how to fix it.
*/


void *print_msg( void *ptr );
void random_sleep();
char *msg1 = "Thread #1";
char *msg2 = "Thread #2";
 

//----------------------------------------
int main()
{
  pthread_t thread1, thread2;
  
  printf("main thread starting\n");
  pthread_create(&thread1, NULL, print_msg, (void*) msg1);
  pthread_create(&thread2, NULL, print_msg, (void*) msg2);
  
  printf("waiting for threads to terminate.\n");
  int* ret_val;
  pthread_join(thread1, (void**) &ret_val);
  printf("Thread1 terminarted. Returned value is: %d.\n", *ret_val);
  pthread_join(thread2, (void**) &ret_val);
  printf("Thread2 terminarted. Returned value is: %d.\n", *ret_val);
  
  exit(0);
}

//----------------------------------------
void *print_msg( void *ptr )
{
  char *msg;
  msg = (char *) ptr;
  random_sleep();
  int num = rand();
  printf("%s : random number is: %d\n", msg, num);
  pthread_exit(&num);
}
//----------------------------------------
void random_sleep()
{
  int d = (rand() ^ pthread_self() ^ getpid()) % 40 + 40;
  const struct timespec ts = {0, d * 1000 * 1000 * 10};
  nanosleep(&ts, NULL);
}
